// Copyright (C) 2002 Andreas Jnsson of www.AngelCode.com

#ifndef ERRORCODES_H
#define ERRORCODES_H

// Macros for checking for either failure or success
#ifndef FAILED
#define FAILED(x) ((x)<0)
#endif

#ifndef SUCCEEDED
#define SUCCEEDED(x) ((x)>=0)
#endif

// Standard codes

// Status Codes that are not errors
#define SC_OK							0
									
// Error Codes that indicate error	
#define EC_General						-1
										
#define EC_BufferTooSmall				-2
#define EC_OutOfMemory					-3
									
#define EC_UnsupportedFormat			-4
#define EC_UnexpectedData				-5
#define EC_CorruptedData				-6
#define EC_DataError					-7
#define EC_Uninitialized				-8
#define EC_InvalidParameters			-9
#define EC_InvalidCall					-10
									
#define EC_CouldNotOpenFile				-11
#define EC_FileIOError					-12
#define EC_DiskIsFull					-13
#define EC_FileAccessError				-14		
#define EC_FileAlreadyExist				-15
#define EC_TooManyFiles					-16
#define EC_FileNotFound					-17
#define EC_EndOfFile					-18

#define EC_FailedToRegisterWindowClass	-19
#define EC_FailedToLoadAccelerators		-20
#define EC_NoWindowClass				-21
#define EC_FailedToCreateWindow			-22

#define EC_DeviceAllocated				-23
#define EC_NoDeviceDriver				-24
#define EC_BadDeviceID					-25

#define EC_Undefined					-0x10000


#endif