//-----------------------------------------------------------------------------
// cSimpleWindow
//
// This class is an interface for the operative system's windows.
//
// To compile with this class you must link with:
// user32.lib gdi32.lib
//
// Copyright (c) 2002 Andreas Jnsson
//-----------------------------------------------------------------------------
#ifndef WINDOW_H
#define WINDOW_H

#define STRICT				// Enable strict type checking
#define WIN32_LEAN_AND_MEAN // Don't include stuff that are rarely used
#include <windows.h>

#define WCF_NORESIZE   0x1
#define WCF_FULLSCREEN 0x2

class cSimpleWindow
{
public:
	cSimpleWindow();

	int  Create(int width, int height, const char *title, DWORD flags); 
	int  Show();
	HWND GetHandle();
	void GetClientRect(RECT *rect);

	static bool CheckMessages(bool wait);

protected:
	HWND hWnd;
	bool isFullscreen;

    virtual LRESULT MsgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	virtual void DispatchMessage(MSG *msg);

	int  CreateWnd(int width, int height, const char *title, DWORD flags);
	int  RegClass(const char *menuName, const char *acceleratorName, 
		   HBRUSH bgBrush, HICON icon, HCURSOR cursor, const char *className);

private:
	static LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

	ATOM   windowClass;
	bool   isUsingMenu;
	HACCEL hAccel;
};

#endif